
    .TEXT
;*****************************************************************
; Output the given text at the given screen position
do_text2:	movem.l	d0-d4/a0-a4,-(sp)

		moveq.l	#0,d3
		move.b	txtcol,d3
		asl.l	#2,d3		; 8 Pixel = 4 Byte
		moveq.l	#0,d4
		move.b	txtrow,d4
		mulu	#15*320/2,d4	; 320 Pixel = 160 Byte
		add.l	d3,d4
		move.l	text_adr,a1
			
		move.l	text_bmp,a2	; Write into which bitmap? 
		
		move.w	#0,d0		; Zhler auf Null setzen
.cLoop:		move.l	a2,a3
		clr.l	d1
		move.b	(a1)+,d1	; Zeichen lesen
		beq.s	do_text_end
		sub.w	#" ",d1		; von 32=Leerzeichen bis 127=Grafikblock
		bmi.s	do_text_end
		addq.w	#1,d0		; Zhler erhhen
		;lea	wABC,a4		; Lade Fontanfang nach a4
		move.l	text_font,a4	; Neu: Fr verschidenfarbige Fonts!
;**		lea     ((15-1)*768)/2(a4),a4; Windows-Bmp
        lea     14*768/2(a4),a4; Windows-Bmp
		asl.l	#2,d1		; die Adresse des
		add.l	d1,a4		; aktuellen Zeichens
		add.l	d4,a3		; plus Spalte,Zeile
		move.w	#15-1,d2	; 15 Zeilen
.text_yloop:
		move.l	0(a4),0(a3)
		lea	-(768/2)(a4),a4
		lea	320/2(a3),a3
		dbf	d2,.text_yloop
		lea	4(a2),a2
		cmp.w	#40,d0
		ble.s	.cLoop
do_text_end:	movem.l	(sp)+,d0-d4/a0-a4
		rts
;****************************************
; Erase the given text out of the given bitmap
clear_text2:	movem.l	d0-d4/a0-a4,-(sp)

		moveq.l	#0,d3
		move.b	txtcol,d3
		asl.l	#2,d3		; 8 Pixel = 4 Byte
		moveq.l	#0,d4
		move.b	txtrow,d4
		mulu	#15*320/2,d4	; 320 Pixel = 160 Byte
		add.l	d3,d4
		move.l	text_adr,a1
		move.l	text_bmp,a2

		move.w	#0,d0		; Zhler auf Null setzen
.ccLoop:	move.l	a2,a3
		clr.l	d1
		move.b	(a1)+,d1	; Zeichen lesen
		beq.s	clear_text_end
		sub.w	#" ",d1		; Leerzeichen bis Unterstrich
		bmi.s	clear_text_end
		addq.w	#1,d0		; Zhler erhhen

		add.l	d4,a3		; plus Spalte,Zeile
		move.w	#15-1,d2	; 15 Zeilen
.ctext_yloop:
		;**clr.l	0(a3)
        move.l  #0,(a3)
		lea	320/2(a3),a3
		dbf	d2,.ctext_yloop

		lea	4(a2),a2
		cmp.w	#40,d0
		ble.s	.ccLoop
clear_text_end:	movem.l	(sp)+,d0-d4/a0-a4
		rts

;********************************************************************
; Create 2 monochrome 4bit fonts
make_fonts:
	move.w	#(96*4/4*15)-1,d0
	lea	wABC,a0
	lea	wABC2,a1
mf_loop:
	move.l	(a0),d1
	move.l	d1,d2
	rol.l	#3,d1		; wABC gets index 8
	or.l	d1,d2		; wABC2 gets index 9
	move.l	d1,(a0)+
	move.l	d2,(a1)+
	dbf	d0,mf_loop
	rts
       
